/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.aufgabe.boundary;

import de.ivu.elect.business.aufgabe.entity.Aufgabe;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class AufgabeDAO extends AbstractAufgabeDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Aufgabe aufgabe){
    getEntityManager().persist(aufgabe);
  }

  public void remove(Aufgabe aufgabe){
    getEntityManager().remove(aufgabe);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Aufgabe o WHERE o.wahl = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Aufgabe> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Aufgabe.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<Aufgabe>) cached;
        }
            return super.findByWahl( wahl  );
            }
                                            
        /**
        * Name: WahlterminNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Aufgabe o WHERE o.wahltermin = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Aufgabe> findByWahltermin( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Aufgabe.findByWahltermin" ,  wahltermin  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahltermin( wahltermin  ));
        }
        return (java.util.List<Aufgabe>) cached;
        }
            return super.findByWahltermin( wahltermin  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}